			page	60,80
;*****************************************************************************
;File:    cpcstart.asm
;Purpose: Startup code for C language control program for Hostess i,
;			 Hostess 186, and Smart Hostess.
;Company: Comtrol Corporation
;Author:  Craig Harrison
;*****************************************************************************
;Copyright 1991-1992 Comtrol Corporation. All rights reserved. Subject to
;developers license agreement.
;*****************************************************************************
;Release: 1.0, 8-23-91, Craig Harrison - Original release
;			 1.1, 7-28-92, Craig Harrison
;				Remove all code except minimum needed for startup.
;				Add support for memory models small, medium, compact, & large.
;				Add support for different controller types. 	

ifdef SMARTH
.186
elseifdef HOSTESS186
.186
elseifdef HOSTESSi
.286
else
.ERR "Controller type incorrectly defined"
endif


ifdef MSMALL
.MODEL small
elseifdef MCOMPACT
.MODEL compact
elseifdef MMEDIUM
.MODEL medium
elseifdef MLARGE
.MODEL large           
else
.ERR "Memory model incorrectly defined"
endif

 
if @CodeSize eq 0								;near code pointer
			extrn		_main:near
else												;far code pointer
			extrn		_main:far
endif


		  assume  cs:_TEXT,ds:DGROUP,es:nothing

.CODE _TEXT								;code segment (_TEXT)
			org 0                   ;starting offset
ifdef	SMARTH										
include	firmuser.equ				;this forces entry point to offset 80H
endif

         public  start, cpmain
cpmain   proc								
start:
			;Initialize segment registers
			cli                     ;disable interrupts
			mov	ax,DGROUP	 
			mov	ds,ax
			mov	es,ax				;known value, not really needed


			;Initialize stack
if @DataSize eq 0						;near data pointers
			assume	ss:DGROUP
			mov	ax,DGROUP
			mov	ss,ax
			mov	sp,offset DGROUP:tos
else										;far data pointers
			assume	ss:_STACK
			mov	ax,_STACK			
			mov	ss,ax
			mov	sp,offset tos
endif


			;Invoke "C" main function
			sti							;enable interrupts
         call	_main					;invoke main function which never returns
			jmp	start					;should never reach here
endp     cpmain



.DATA										;initialized data segment (_DATA)
			public	_endcp_seg
_endcp_seg	dw		ENDCP				;segment after end of control program for
											;  use by "C" code

.CONST									;constant data segment (CONST)

.DATA?									;uninitialized data segment (_BSS)



;Not using simplified segment directive for stack because MASM mode closes the
;stack segment before we can assign the tos label (see Turbo Assembler 3.0,
;page 115).

if @DataSize eq 0        					;for near data pointers
DGROUP	group		_STACK					;  stack is part of DGROUP
endif

			public	tos
_STACK	segment	para	stack		'STACK'	;stack segment (_STACK)
			db			STACK_SIZE	dup	(?)
			align	2						;make sure SP starts out with word allignment
tos		label	word					;top of stack
_STACK	ends


.FARDATA											;far initialized data seg (FAR_DATA)

.FARDATA?										;far uninitialized data seg (FAR_BSS)


ENDCP		segment	para	private	'ENDCP'	;marks end of control program
ENDCP		ends

			end	start
