/******************************************************************************
 File:    firmuser.h
 Purpose: Firmware user area definition.
 Company: Comtrol Corporation
 Comments: This matches the assembly language definition in firmuser.equ.
*******************************************************************************
 Copyright 1992 Comtrol Corporation. All rights reserved. Subject to developers
 license agreement.
******************************************************************************/

typedef struct
{
   unsigned i_flag;                    /* processor interaction flag */
   unsigned boot_flag;                 /* boot/activity flag */
   unsigned cfg_map;                   /* configuration map */
   char fw_release[8];                 /* firmware release number */
   char sw_release[8];                 /* control program release number */
   unsigned long dram_map1;            /* DRAM map */
   unsigned long dram_map2;            /* DRAM map */
   unsigned long scc_map;              /* SCC map */
   unsigned long board_id;             /* board ID */
   char ii_flag;                       /* invalid interrupt flag */
   char ii_type;                       /* invalid interrupt type */
   unsigned ii_cnt;                    /* invalid interrupt count */
   unsigned long heartbeat;            /* heartbeat counter */
   char cmd;                           /* firmware utility command */
   char status;                        /* firmware utility status */
   char msg[16];                       /* firmware utility message buffer */
   char reserved1[0x40];               /* reserved for future use */
} FIRMUSER_T;
